/* Signal Variants -- Generated file, don't edit. */

# 0 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3>
struct Handler3 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3>
class HandlerF3 : public Handler3 <R0, A1, A2, A3> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3)
  { return callback (a1, a2, a3); }
  ~HandlerF3() {}
public:
  HandlerF3 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3>
class HandlerM3 : public Handler3 <R0, A1, A2, A3> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3)
  { return (instance->*method) (a1, a2, a3); }
  ~HandlerM3() {}
public:
  HandlerM3 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename Data>
class HandlerDF3 : public Handler3 <R0, A1, A2, A3> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3)
  { return callback (a1, a2, a3, data); }
  ~HandlerDF3() {}
public:
  HandlerDF3 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename Data>
class HandlerDM3 : public Handler3 <R0, A1, A2, A3> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3)
  { return (instance->*method) (a1, a2, a3, data); }
  ~HandlerDM3() {}
public:
  HandlerDM3 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, class Emitter = void>
struct Slot3 : SlotBase {
  Slot3 (Handler3<R0, A1, A2, A3>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3> Slot3<R0, A1, A2, A3>
slot (R0 (*callback) (A1, A2, A3))
{
  return Slot3<R0, A1, A2, A3> (new HandlerF3<R0, A1, A2, A3> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename Data> Slot3<R0, A1, A2, A3>
slot (R0 (*callback) (A1, A2, A3, Data), const Data &data)
{
  return Slot3<R0, A1, A2, A3> (new HandlerDF3<R0, A1, A2, A3, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3> Slot3<R0, A1, A2, A3>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3))
{
  return Slot3<R0, A1, A2, A3> (new HandlerM3<Class, R0, A1, A2, A3> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename Data> Slot3<R0, A1, A2, A3>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3), const Data &data)
{
  return Slot3<R0, A1, A2, A3> (new HandlerDM3<Class, R0, A1, A2, A3, Data> (obj, method, data));
}
# 99000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0>
struct Handler0 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() () = 0;
};

/* --- Handler (plain) --- */
template<typename R0>
class HandlerF0 : public Handler0 <R0> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) ();
  Callback callback;
  virtual R0 operator() ()
  { return callback (); }
  ~HandlerF0() {}
public:
  HandlerF0 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0>
class HandlerM0 : public Handler0 <R0> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) ();
  Class *instance;
  Method method;
  virtual R0 operator() ()
  { return (instance->*method) (); }
  ~HandlerM0() {}
public:
  HandlerM0 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename Data>
class HandlerDF0 : public Handler0 <R0> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) ( Data);
  Callback callback; Data data;
  virtual R0 operator() ()
  { return callback ( data); }
  ~HandlerDF0() {}
public:
  HandlerDF0 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename Data>
class HandlerDM0 : public Handler0 <R0> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) ( Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() ()
  { return (instance->*method) ( data); }
  ~HandlerDM0() {}
public:
  HandlerDM0 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, class Emitter = void>
struct Slot0 : SlotBase {
  Slot0 (Handler0<R0>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0> Slot0<R0>
slot (R0 (*callback) ())
{
  return Slot0<R0> (new HandlerF0<R0> (callback));
}
template<typename R0, typename Data> Slot0<R0>
slot (R0 (*callback) ( Data), const Data &data)
{
  return Slot0<R0> (new HandlerDF0<R0, Data> (callback, data));
}
template<class Class, typename R0> Slot0<R0>
slot (Class &obj, R0 (Class::*method) ())
{
  return Slot0<R0> (new HandlerM0<Class, R0> (obj, method));
}
template<class Class, typename R0, typename Data> Slot0<R0>
slot (Class &obj, R0 (Class::*method) (), const Data &data)
{
  return Slot0<R0> (new HandlerDM0<Class, R0, Data> (obj, method, data));
}
# 10000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1>
struct Handler1 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1>
class HandlerF1 : public Handler1 <R0, A1> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1);
  Callback callback;
  virtual R0 operator() (A1 a1)
  { return callback (a1); }
  ~HandlerF1() {}
public:
  HandlerF1 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1>
class HandlerM1 : public Handler1 <R0, A1> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1)
  { return (instance->*method) (a1); }
  ~HandlerM1() {}
public:
  HandlerM1 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename Data>
class HandlerDF1 : public Handler1 <R0, A1> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1)
  { return callback (a1, data); }
  ~HandlerDF1() {}
public:
  HandlerDF1 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename Data>
class HandlerDM1 : public Handler1 <R0, A1> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1)
  { return (instance->*method) (a1, data); }
  ~HandlerDM1() {}
public:
  HandlerDM1 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, class Emitter = void>
struct Slot1 : SlotBase {
  Slot1 (Handler1<R0, A1>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1> Slot1<R0, A1>
slot (R0 (*callback) (A1))
{
  return Slot1<R0, A1> (new HandlerF1<R0, A1> (callback));
}
template<typename R0, typename A1, typename Data> Slot1<R0, A1>
slot (R0 (*callback) (A1, Data), const Data &data)
{
  return Slot1<R0, A1> (new HandlerDF1<R0, A1, Data> (callback, data));
}
template<class Class, typename R0, typename A1> Slot1<R0, A1>
slot (Class &obj, R0 (Class::*method) (A1))
{
  return Slot1<R0, A1> (new HandlerM1<Class, R0, A1> (obj, method));
}
template<class Class, typename R0, typename A1, typename Data> Slot1<R0, A1>
slot (Class &obj, R0 (Class::*method) (A1), const Data &data)
{
  return Slot1<R0, A1> (new HandlerDM1<Class, R0, A1, Data> (obj, method, data));
}
# 20000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2>
struct Handler2 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2>
class HandlerF2 : public Handler2 <R0, A1, A2> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2)
  { return callback (a1, a2); }
  ~HandlerF2() {}
public:
  HandlerF2 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2>
class HandlerM2 : public Handler2 <R0, A1, A2> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2)
  { return (instance->*method) (a1, a2); }
  ~HandlerM2() {}
public:
  HandlerM2 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename Data>
class HandlerDF2 : public Handler2 <R0, A1, A2> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2)
  { return callback (a1, a2, data); }
  ~HandlerDF2() {}
public:
  HandlerDF2 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename Data>
class HandlerDM2 : public Handler2 <R0, A1, A2> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2)
  { return (instance->*method) (a1, a2, data); }
  ~HandlerDM2() {}
public:
  HandlerDM2 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, class Emitter = void>
struct Slot2 : SlotBase {
  Slot2 (Handler2<R0, A1, A2>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2> Slot2<R0, A1, A2>
slot (R0 (*callback) (A1, A2))
{
  return Slot2<R0, A1, A2> (new HandlerF2<R0, A1, A2> (callback));
}
template<typename R0, typename A1, typename A2, typename Data> Slot2<R0, A1, A2>
slot (R0 (*callback) (A1, A2, Data), const Data &data)
{
  return Slot2<R0, A1, A2> (new HandlerDF2<R0, A1, A2, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2> Slot2<R0, A1, A2>
slot (Class &obj, R0 (Class::*method) (A1, A2))
{
  return Slot2<R0, A1, A2> (new HandlerM2<Class, R0, A1, A2> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename Data> Slot2<R0, A1, A2>
slot (Class &obj, R0 (Class::*method) (A1, A2), const Data &data)
{
  return Slot2<R0, A1, A2> (new HandlerDM2<Class, R0, A1, A2, Data> (obj, method, data));
}
# 40000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4>
struct Handler4 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4>
class HandlerF4 : public Handler4 <R0, A1, A2, A3, A4> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4)
  { return callback (a1, a2, a3, a4); }
  ~HandlerF4() {}
public:
  HandlerF4 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4>
class HandlerM4 : public Handler4 <R0, A1, A2, A3, A4> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4)
  { return (instance->*method) (a1, a2, a3, a4); }
  ~HandlerM4() {}
public:
  HandlerM4 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename Data>
class HandlerDF4 : public Handler4 <R0, A1, A2, A3, A4> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4)
  { return callback (a1, a2, a3, a4, data); }
  ~HandlerDF4() {}
public:
  HandlerDF4 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename Data>
class HandlerDM4 : public Handler4 <R0, A1, A2, A3, A4> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4)
  { return (instance->*method) (a1, a2, a3, a4, data); }
  ~HandlerDM4() {}
public:
  HandlerDM4 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, class Emitter = void>
struct Slot4 : SlotBase {
  Slot4 (Handler4<R0, A1, A2, A3, A4>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4> Slot4<R0, A1, A2, A3, A4>
slot (R0 (*callback) (A1, A2, A3, A4))
{
  return Slot4<R0, A1, A2, A3, A4> (new HandlerF4<R0, A1, A2, A3, A4> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename Data> Slot4<R0, A1, A2, A3, A4>
slot (R0 (*callback) (A1, A2, A3, A4, Data), const Data &data)
{
  return Slot4<R0, A1, A2, A3, A4> (new HandlerDF4<R0, A1, A2, A3, A4, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4> Slot4<R0, A1, A2, A3, A4>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4))
{
  return Slot4<R0, A1, A2, A3, A4> (new HandlerM4<Class, R0, A1, A2, A3, A4> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename Data> Slot4<R0, A1, A2, A3, A4>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4), const Data &data)
{
  return Slot4<R0, A1, A2, A3, A4> (new HandlerDM4<Class, R0, A1, A2, A3, A4, Data> (obj, method, data));
}
# 50000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5>
struct Handler5 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5>
class HandlerF5 : public Handler5 <R0, A1, A2, A3, A4, A5> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5)
  { return callback (a1, a2, a3, a4, a5); }
  ~HandlerF5() {}
public:
  HandlerF5 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5>
class HandlerM5 : public Handler5 <R0, A1, A2, A3, A4, A5> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5)
  { return (instance->*method) (a1, a2, a3, a4, a5); }
  ~HandlerM5() {}
public:
  HandlerM5 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename Data>
class HandlerDF5 : public Handler5 <R0, A1, A2, A3, A4, A5> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5)
  { return callback (a1, a2, a3, a4, a5, data); }
  ~HandlerDF5() {}
public:
  HandlerDF5 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename Data>
class HandlerDM5 : public Handler5 <R0, A1, A2, A3, A4, A5> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5)
  { return (instance->*method) (a1, a2, a3, a4, a5, data); }
  ~HandlerDM5() {}
public:
  HandlerDM5 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, class Emitter = void>
struct Slot5 : SlotBase {
  Slot5 (Handler5<R0, A1, A2, A3, A4, A5>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5> Slot5<R0, A1, A2, A3, A4, A5>
slot (R0 (*callback) (A1, A2, A3, A4, A5))
{
  return Slot5<R0, A1, A2, A3, A4, A5> (new HandlerF5<R0, A1, A2, A3, A4, A5> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename Data> Slot5<R0, A1, A2, A3, A4, A5>
slot (R0 (*callback) (A1, A2, A3, A4, A5, Data), const Data &data)
{
  return Slot5<R0, A1, A2, A3, A4, A5> (new HandlerDF5<R0, A1, A2, A3, A4, A5, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5> Slot5<R0, A1, A2, A3, A4, A5>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5))
{
  return Slot5<R0, A1, A2, A3, A4, A5> (new HandlerM5<Class, R0, A1, A2, A3, A4, A5> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename Data> Slot5<R0, A1, A2, A3, A4, A5>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5), const Data &data)
{
  return Slot5<R0, A1, A2, A3, A4, A5> (new HandlerDM5<Class, R0, A1, A2, A3, A4, A5, Data> (obj, method, data));
}
# 60000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6>
struct Handler6 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6>
class HandlerF6 : public Handler6 <R0, A1, A2, A3, A4, A5, A6> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6)
  { return callback (a1, a2, a3, a4, a5, a6); }
  ~HandlerF6() {}
public:
  HandlerF6 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6>
class HandlerM6 : public Handler6 <R0, A1, A2, A3, A4, A5, A6> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6); }
  ~HandlerM6() {}
public:
  HandlerM6 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename Data>
class HandlerDF6 : public Handler6 <R0, A1, A2, A3, A4, A5, A6> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6)
  { return callback (a1, a2, a3, a4, a5, a6, data); }
  ~HandlerDF6() {}
public:
  HandlerDF6 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename Data>
class HandlerDM6 : public Handler6 <R0, A1, A2, A3, A4, A5, A6> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, data); }
  ~HandlerDM6() {}
public:
  HandlerDM6 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, class Emitter = void>
struct Slot6 : SlotBase {
  Slot6 (Handler6<R0, A1, A2, A3, A4, A5, A6>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6> Slot6<R0, A1, A2, A3, A4, A5, A6>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6))
{
  return Slot6<R0, A1, A2, A3, A4, A5, A6> (new HandlerF6<R0, A1, A2, A3, A4, A5, A6> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename Data> Slot6<R0, A1, A2, A3, A4, A5, A6>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, Data), const Data &data)
{
  return Slot6<R0, A1, A2, A3, A4, A5, A6> (new HandlerDF6<R0, A1, A2, A3, A4, A5, A6, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6> Slot6<R0, A1, A2, A3, A4, A5, A6>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6))
{
  return Slot6<R0, A1, A2, A3, A4, A5, A6> (new HandlerM6<Class, R0, A1, A2, A3, A4, A5, A6> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename Data> Slot6<R0, A1, A2, A3, A4, A5, A6>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6), const Data &data)
{
  return Slot6<R0, A1, A2, A3, A4, A5, A6> (new HandlerDM6<Class, R0, A1, A2, A3, A4, A5, A6, Data> (obj, method, data));
}
# 70000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7>
struct Handler7 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7>
class HandlerF7 : public Handler7 <R0, A1, A2, A3, A4, A5, A6, A7> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7)
  { return callback (a1, a2, a3, a4, a5, a6, a7); }
  ~HandlerF7() {}
public:
  HandlerF7 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7>
class HandlerM7 : public Handler7 <R0, A1, A2, A3, A4, A5, A6, A7> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7); }
  ~HandlerM7() {}
public:
  HandlerM7 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename Data>
class HandlerDF7 : public Handler7 <R0, A1, A2, A3, A4, A5, A6, A7> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7)
  { return callback (a1, a2, a3, a4, a5, a6, a7, data); }
  ~HandlerDF7() {}
public:
  HandlerDF7 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename Data>
class HandlerDM7 : public Handler7 <R0, A1, A2, A3, A4, A5, A6, A7> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, data); }
  ~HandlerDM7() {}
public:
  HandlerDM7 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, class Emitter = void>
struct Slot7 : SlotBase {
  Slot7 (Handler7<R0, A1, A2, A3, A4, A5, A6, A7>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7> Slot7<R0, A1, A2, A3, A4, A5, A6, A7>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7))
{
  return Slot7<R0, A1, A2, A3, A4, A5, A6, A7> (new HandlerF7<R0, A1, A2, A3, A4, A5, A6, A7> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename Data> Slot7<R0, A1, A2, A3, A4, A5, A6, A7>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, Data), const Data &data)
{
  return Slot7<R0, A1, A2, A3, A4, A5, A6, A7> (new HandlerDF7<R0, A1, A2, A3, A4, A5, A6, A7, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7> Slot7<R0, A1, A2, A3, A4, A5, A6, A7>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7))
{
  return Slot7<R0, A1, A2, A3, A4, A5, A6, A7> (new HandlerM7<Class, R0, A1, A2, A3, A4, A5, A6, A7> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename Data> Slot7<R0, A1, A2, A3, A4, A5, A6, A7>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7), const Data &data)
{
  return Slot7<R0, A1, A2, A3, A4, A5, A6, A7> (new HandlerDM7<Class, R0, A1, A2, A3, A4, A5, A6, A7, Data> (obj, method, data));
}
# 80000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8>
struct Handler8 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8>
class HandlerF8 : public Handler8 <R0, A1, A2, A3, A4, A5, A6, A7, A8> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8); }
  ~HandlerF8() {}
public:
  HandlerF8 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8>
class HandlerM8 : public Handler8 <R0, A1, A2, A3, A4, A5, A6, A7, A8> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8); }
  ~HandlerM8() {}
public:
  HandlerM8 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename Data>
class HandlerDF8 : public Handler8 <R0, A1, A2, A3, A4, A5, A6, A7, A8> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, data); }
  ~HandlerDF8() {}
public:
  HandlerDF8 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename Data>
class HandlerDM8 : public Handler8 <R0, A1, A2, A3, A4, A5, A6, A7, A8> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, data); }
  ~HandlerDM8() {}
public:
  HandlerDM8 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, class Emitter = void>
struct Slot8 : SlotBase {
  Slot8 (Handler8<R0, A1, A2, A3, A4, A5, A6, A7, A8>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8> Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8))
{
  return Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8> (new HandlerF8<R0, A1, A2, A3, A4, A5, A6, A7, A8> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename Data> Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, Data), const Data &data)
{
  return Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8> (new HandlerDF8<R0, A1, A2, A3, A4, A5, A6, A7, A8, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8> Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8))
{
  return Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8> (new HandlerM8<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename Data> Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8), const Data &data)
{
  return Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8> (new HandlerDM8<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, Data> (obj, method, data));
}
# 90000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9>
struct Handler9 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9>
class HandlerF9 : public Handler9 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9); }
  ~HandlerF9() {}
public:
  HandlerF9 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9>
class HandlerM9 : public Handler9 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9); }
  ~HandlerM9() {}
public:
  HandlerM9 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename Data>
class HandlerDF9 : public Handler9 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, data); }
  ~HandlerDF9() {}
public:
  HandlerDF9 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename Data>
class HandlerDM9 : public Handler9 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, data); }
  ~HandlerDM9() {}
public:
  HandlerDM9 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, class Emitter = void>
struct Slot9 : SlotBase {
  Slot9 (Handler9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9> Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9))
{
  return Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> (new HandlerF9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename Data> Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, Data), const Data &data)
{
  return Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> (new HandlerDF9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9> Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9))
{
  return Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> (new HandlerM9<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename Data> Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9), const Data &data)
{
  return Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> (new HandlerDM9<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, Data> (obj, method, data));
}
# 100000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10>
struct Handler10 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10>
class HandlerF10 : public Handler10 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10); }
  ~HandlerF10() {}
public:
  HandlerF10 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10>
class HandlerM10 : public Handler10 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10); }
  ~HandlerM10() {}
public:
  HandlerM10 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename Data>
class HandlerDF10 : public Handler10 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, data); }
  ~HandlerDF10() {}
public:
  HandlerDF10 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename Data>
class HandlerDM10 : public Handler10 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, data); }
  ~HandlerDM10() {}
public:
  HandlerDM10 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, class Emitter = void>
struct Slot10 : SlotBase {
  Slot10 (Handler10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10> Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10))
{
  return Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> (new HandlerF10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename Data> Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Data), const Data &data)
{
  return Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> (new HandlerDF10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10> Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10))
{
  return Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> (new HandlerM10<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename Data> Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10), const Data &data)
{
  return Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> (new HandlerDM10<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Data> (obj, method, data));
}
# 110000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11>
struct Handler11 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11>
class HandlerF11 : public Handler11 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11); }
  ~HandlerF11() {}
public:
  HandlerF11 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11>
class HandlerM11 : public Handler11 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11); }
  ~HandlerM11() {}
public:
  HandlerM11 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename Data>
class HandlerDF11 : public Handler11 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, data); }
  ~HandlerDF11() {}
public:
  HandlerDF11 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename Data>
class HandlerDM11 : public Handler11 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, data); }
  ~HandlerDM11() {}
public:
  HandlerDM11 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, class Emitter = void>
struct Slot11 : SlotBase {
  Slot11 (Handler11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11> Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11))
{
  return Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> (new HandlerF11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename Data> Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Data), const Data &data)
{
  return Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> (new HandlerDF11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11> Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11))
{
  return Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> (new HandlerM11<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename Data> Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11), const Data &data)
{
  return Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> (new HandlerDM11<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Data> (obj, method, data));
}
# 120000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12>
struct Handler12 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12>
class HandlerF12 : public Handler12 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12); }
  ~HandlerF12() {}
public:
  HandlerF12 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12>
class HandlerM12 : public Handler12 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12); }
  ~HandlerM12() {}
public:
  HandlerM12 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename Data>
class HandlerDF12 : public Handler12 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, data); }
  ~HandlerDF12() {}
public:
  HandlerDF12 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename Data>
class HandlerDM12 : public Handler12 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, data); }
  ~HandlerDM12() {}
public:
  HandlerDM12 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, class Emitter = void>
struct Slot12 : SlotBase {
  Slot12 (Handler12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12> Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12))
{
  return Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> (new HandlerF12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename Data> Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Data), const Data &data)
{
  return Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> (new HandlerDF12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12> Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12))
{
  return Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> (new HandlerM12<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename Data> Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12), const Data &data)
{
  return Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> (new HandlerDM12<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Data> (obj, method, data));
}
# 130000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13>
struct Handler13 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13>
class HandlerF13 : public Handler13 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13); }
  ~HandlerF13() {}
public:
  HandlerF13 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13>
class HandlerM13 : public Handler13 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13); }
  ~HandlerM13() {}
public:
  HandlerM13 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename Data>
class HandlerDF13 : public Handler13 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, data); }
  ~HandlerDF13() {}
public:
  HandlerDF13 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename Data>
class HandlerDM13 : public Handler13 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, data); }
  ~HandlerDM13() {}
public:
  HandlerDM13 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, class Emitter = void>
struct Slot13 : SlotBase {
  Slot13 (Handler13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13> Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13))
{
  return Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> (new HandlerF13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename Data> Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Data), const Data &data)
{
  return Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> (new HandlerDF13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13> Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13))
{
  return Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> (new HandlerM13<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename Data> Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13), const Data &data)
{
  return Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> (new HandlerDM13<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Data> (obj, method, data));
}
# 140000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14>
struct Handler14 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14>
class HandlerF14 : public Handler14 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14); }
  ~HandlerF14() {}
public:
  HandlerF14 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14>
class HandlerM14 : public Handler14 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14); }
  ~HandlerM14() {}
public:
  HandlerM14 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename Data>
class HandlerDF14 : public Handler14 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, data); }
  ~HandlerDF14() {}
public:
  HandlerDF14 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename Data>
class HandlerDM14 : public Handler14 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, data); }
  ~HandlerDM14() {}
public:
  HandlerDM14 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, class Emitter = void>
struct Slot14 : SlotBase {
  Slot14 (Handler14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14> Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14))
{
  return Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> (new HandlerF14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename Data> Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Data), const Data &data)
{
  return Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> (new HandlerDF14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14> Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14))
{
  return Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> (new HandlerM14<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename Data> Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14), const Data &data)
{
  return Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> (new HandlerDM14<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Data> (obj, method, data));
}
# 150000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15>
struct Handler15 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15>
class HandlerF15 : public Handler15 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15); }
  ~HandlerF15() {}
public:
  HandlerF15 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15>
class HandlerM15 : public Handler15 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15); }
  ~HandlerM15() {}
public:
  HandlerM15 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename Data>
class HandlerDF15 : public Handler15 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, data); }
  ~HandlerDF15() {}
public:
  HandlerDF15 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename Data>
class HandlerDM15 : public Handler15 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, data); }
  ~HandlerDM15() {}
public:
  HandlerDM15 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, class Emitter = void>
struct Slot15 : SlotBase {
  Slot15 (Handler15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15> Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15))
{
  return Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> (new HandlerF15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename Data> Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Data), const Data &data)
{
  return Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> (new HandlerDF15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15> Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15))
{
  return Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> (new HandlerM15<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename Data> Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15), const Data &data)
{
  return Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> (new HandlerDM15<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Data> (obj, method, data));
}
# 160000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16>
struct Handler16 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16>
class HandlerF16 : public Handler16 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16); }
  ~HandlerF16() {}
public:
  HandlerF16 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16>
class HandlerM16 : public Handler16 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16); }
  ~HandlerM16() {}
public:
  HandlerM16 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename Data>
class HandlerDF16 : public Handler16 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, data); }
  ~HandlerDF16() {}
public:
  HandlerDF16 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename Data>
class HandlerDM16 : public Handler16 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, data); }
  ~HandlerDM16() {}
public:
  HandlerDM16 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, class Emitter = void>
struct Slot16 : SlotBase {
  Slot16 (Handler16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16> Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16))
{
  return Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> (new HandlerF16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename Data> Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Data), const Data &data)
{
  return Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> (new HandlerDF16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16> Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16))
{
  return Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> (new HandlerM16<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename Data> Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16), const Data &data)
{
  return Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> (new HandlerDM16<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Data> (obj, method, data));
}
# 170000 "./birnetsignalslot.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Handler (basis signature) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17>
struct Handler17 : public SignalBase::Link {
  /* signature type for all signal handlers, used for handler invocations by Emission */
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16, A17 a17) = 0;
};

/* --- Handler (plain) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17>
class HandlerF17 : public Handler17 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17);
  Callback callback;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16, A17 a17)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17); }
  ~HandlerF17() {}
public:
  HandlerF17 (Callback c) :
    callback (c)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17>
class HandlerM17 : public Handler17 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17);
  Class *instance;
  Method method;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16, A17 a17)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17); }
  ~HandlerM17() {}
public:
  HandlerM17 (Class &obj, Method m) :
    instance (&obj), method (m)
  {}
};

/* --- Handler with Data --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17, typename Data>
class HandlerDF17 : public Handler17 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (*Callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17, Data);
  Callback callback; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16, A17 a17)
  { return callback (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, data); }
  ~HandlerDF17() {}
public:
  HandlerDF17 (Callback c, const Data &d) :
    callback (c), data (d)
  {}
};
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17, typename Data>
class HandlerDM17 : public Handler17 <R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> {
  friend void FIXME_dummy_friend_for_gcc33();
  typedef R0 (Class::*Method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17, Data);
  Class *instance; Method method; Data data;
  virtual R0 operator() (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16, A17 a17)
  { return (instance->*method) (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, data); }
  ~HandlerDM17() {}
public:
  HandlerDM17 (Class &obj, Method m, const Data &d) :
    instance (&obj), method (m), data (d)
  {}
};

/* --- Slots (Handler wrappers) --- */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17, class Emitter = void>
struct Slot17 : SlotBase {
  Slot17 (Handler17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17>           *handler) : SlotBase (handler) {}
};
/* slot constructors */
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17> Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17))
{
  return Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> (new HandlerF17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> (callback));
}
template<typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17, typename Data> Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17>
slot (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17, Data), const Data &data)
{
  return Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> (new HandlerDF17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17, Data> (callback, data));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17> Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17))
{
  return Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> (new HandlerM17<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> (obj, method));
}
template<class Class, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, typename A17, typename Data> Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17>
slot (Class &obj, R0 (Class::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17), const Data &data)
{
  return Slot17<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17> (new HandlerDM17<Class, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17, Data> (obj, method, data));
}
# 0 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3>
struct Emission3 : public EmissionBase {
  typedef Handler3<R0, A1, A2, A3>           Handler;
  typedef Handler4<R0, Emitter&, A1, A2, A3> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3;
  SignalBase::Link *m_last_link;
  Emission3 (Emitter *emitter, A1 a1, A2 a2, A3 a3) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3>
struct Emission3 <Emitter, void, A1, A2, A3> : public EmissionBase {
  typedef Handler3<void, A1, A2, A3>           Handler;
  typedef Handler4<void, Emitter&, A1, A2, A3> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3;
  Emission3 (Emitter *emitter, A1 a1, A2 a2, A3 a3) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3);
      }
  }
};

/* --- SignalEmittable3 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, class Collector>
struct SignalEmittable3 : SignalBase {
  typedef Emission3 <Emitter, R0, A1, A2, A3> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable3 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable3 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, class Collector>
struct SignalEmittable3 <Emitter, void, A1, A2, A3, Collector> : SignalBase {
  typedef Emission3 <Emitter, void, A1, A2, A3> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable3 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal3 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, class Collector = CollectorDefault<R0> >
struct Signal3 : SignalEmittable3<Emitter, R0, A1, A2, A3, Collector>
{
  typedef Emission3 <Emitter, R0, A1, A2, A3> Emission;
  typedef Slot3<R0, A1, A2, A3>               Slot;
  typedef Slot4<R0, Emitter&, A1, A2, A3>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable3<Emitter, R0, A1, A2, A3, Collector> SignalEmittable;
  explicit Signal3 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal3 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal3&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal3&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal3&    operator+= (R0 (*callback) (A1, A2, A3))            { connect (slot (callback)); return *this; }
  Signal3&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal3);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3), Collector> : Signal3<Emitter, R0, A1, A2, A3, Collector>
{
  typedef Signal3<Emitter, R0, A1, A2, A3, Collector> Signal3;
  explicit Signal (Emitter &emitter) :
    Signal3 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3)) :
    Signal3 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 99000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0>
struct Emission0 : public EmissionBase {
  typedef Handler0<R0>           Handler;
  typedef Handler1<R0, Emitter&> HandlerE;
  Emitter *m_emitter;
  R0 m_result; 
  SignalBase::Link *m_last_link;
  Emission0 (Emitter *emitter) :
    m_emitter (emitter), m_result(), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) ();
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter>
struct Emission0 <Emitter, void> : public EmissionBase {
  typedef Handler0<void>           Handler;
  typedef Handler1<void, Emitter&> HandlerE;
  Emitter *m_emitter;
  
  Emission0 (Emitter *emitter) :
    m_emitter (emitter)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) ();
      }
  }
};

/* --- SignalEmittable0 --- */
template<class Emitter, typename R0, class Collector>
struct SignalEmittable0 : SignalBase {
  typedef Emission0 <Emitter, R0> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable0 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit ()
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable0 for void returns */
template<class Emitter, class Collector>
struct SignalEmittable0 <Emitter, void, Collector> : SignalBase {
  typedef Emission0 <Emitter, void> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable0 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit ()
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal0 --- */
/* Signal* */
template<class Emitter, typename R0, class Collector = CollectorDefault<R0> >
struct Signal0 : SignalEmittable0<Emitter, R0, Collector>
{
  typedef Emission0 <Emitter, R0> Emission;
  typedef Slot0<R0>               Slot;
  typedef Slot1<R0, Emitter&>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable0<Emitter, R0, Collector> SignalEmittable;
  explicit Signal0 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal0 (Emitter &emitter, R0 (Emitter::*method) ()) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal0&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal0&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal0&    operator+= (R0 (*callback) ())            { connect (slot (callback)); return *this; }
  Signal0&    operator+= (R0 (*callback) (Emitter&))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal0);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, class Collector>
struct Signal<Emitter, R0 (), Collector> : Signal0<Emitter, R0, Collector>
{
  typedef Signal0<Emitter, R0, Collector> Signal0;
  explicit Signal (Emitter &emitter) :
    Signal0 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) ()) :
    Signal0 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 10000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1>
struct Emission1 : public EmissionBase {
  typedef Handler1<R0, A1>           Handler;
  typedef Handler2<R0, Emitter&, A1> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1;
  SignalBase::Link *m_last_link;
  Emission1 (Emitter *emitter, A1 a1) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1>
struct Emission1 <Emitter, void, A1> : public EmissionBase {
  typedef Handler1<void, A1>           Handler;
  typedef Handler2<void, Emitter&, A1> HandlerE;
  Emitter *m_emitter;
  A1 m_a1;
  Emission1 (Emitter *emitter, A1 a1) :
    m_emitter (emitter), m_a1 (a1)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1);
      }
  }
};

/* --- SignalEmittable1 --- */
template<class Emitter, typename R0, typename A1, class Collector>
struct SignalEmittable1 : SignalBase {
  typedef Emission1 <Emitter, R0, A1> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable1 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable1 for void returns */
template<class Emitter, typename A1, class Collector>
struct SignalEmittable1 <Emitter, void, A1, Collector> : SignalBase {
  typedef Emission1 <Emitter, void, A1> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable1 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal1 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, class Collector = CollectorDefault<R0> >
struct Signal1 : SignalEmittable1<Emitter, R0, A1, Collector>
{
  typedef Emission1 <Emitter, R0, A1> Emission;
  typedef Slot1<R0, A1>               Slot;
  typedef Slot2<R0, Emitter&, A1>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable1<Emitter, R0, A1, Collector> SignalEmittable;
  explicit Signal1 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal1 (Emitter &emitter, R0 (Emitter::*method) (A1)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal1&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal1&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal1&    operator+= (R0 (*callback) (A1))            { connect (slot (callback)); return *this; }
  Signal1&    operator+= (R0 (*callback) (Emitter&, A1))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal1);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, class Collector>
struct Signal<Emitter, R0 (A1), Collector> : Signal1<Emitter, R0, A1, Collector>
{
  typedef Signal1<Emitter, R0, A1, Collector> Signal1;
  explicit Signal (Emitter &emitter) :
    Signal1 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1)) :
    Signal1 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 20000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2>
struct Emission2 : public EmissionBase {
  typedef Handler2<R0, A1, A2>           Handler;
  typedef Handler3<R0, Emitter&, A1, A2> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2;
  SignalBase::Link *m_last_link;
  Emission2 (Emitter *emitter, A1 a1, A2 a2) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2>
struct Emission2 <Emitter, void, A1, A2> : public EmissionBase {
  typedef Handler2<void, A1, A2>           Handler;
  typedef Handler3<void, Emitter&, A1, A2> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2;
  Emission2 (Emitter *emitter, A1 a1, A2 a2) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2);
      }
  }
};

/* --- SignalEmittable2 --- */
template<class Emitter, typename R0, typename A1, typename A2, class Collector>
struct SignalEmittable2 : SignalBase {
  typedef Emission2 <Emitter, R0, A1, A2> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable2 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable2 for void returns */
template<class Emitter, typename A1, typename A2, class Collector>
struct SignalEmittable2 <Emitter, void, A1, A2, Collector> : SignalBase {
  typedef Emission2 <Emitter, void, A1, A2> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable2 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal2 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, class Collector = CollectorDefault<R0> >
struct Signal2 : SignalEmittable2<Emitter, R0, A1, A2, Collector>
{
  typedef Emission2 <Emitter, R0, A1, A2> Emission;
  typedef Slot2<R0, A1, A2>               Slot;
  typedef Slot3<R0, Emitter&, A1, A2>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable2<Emitter, R0, A1, A2, Collector> SignalEmittable;
  explicit Signal2 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal2 (Emitter &emitter, R0 (Emitter::*method) (A1, A2)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal2&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal2&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal2&    operator+= (R0 (*callback) (A1, A2))            { connect (slot (callback)); return *this; }
  Signal2&    operator+= (R0 (*callback) (Emitter&, A1, A2))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal2);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, class Collector>
struct Signal<Emitter, R0 (A1, A2), Collector> : Signal2<Emitter, R0, A1, A2, Collector>
{
  typedef Signal2<Emitter, R0, A1, A2, Collector> Signal2;
  explicit Signal (Emitter &emitter) :
    Signal2 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2)) :
    Signal2 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 40000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4>
struct Emission4 : public EmissionBase {
  typedef Handler4<R0, A1, A2, A3, A4>           Handler;
  typedef Handler5<R0, Emitter&, A1, A2, A3, A4> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4;
  SignalBase::Link *m_last_link;
  Emission4 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4>
struct Emission4 <Emitter, void, A1, A2, A3, A4> : public EmissionBase {
  typedef Handler4<void, A1, A2, A3, A4>           Handler;
  typedef Handler5<void, Emitter&, A1, A2, A3, A4> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4;
  Emission4 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4);
      }
  }
};

/* --- SignalEmittable4 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, class Collector>
struct SignalEmittable4 : SignalBase {
  typedef Emission4 <Emitter, R0, A1, A2, A3, A4> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable4 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable4 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, class Collector>
struct SignalEmittable4 <Emitter, void, A1, A2, A3, A4, Collector> : SignalBase {
  typedef Emission4 <Emitter, void, A1, A2, A3, A4> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable4 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal4 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, class Collector = CollectorDefault<R0> >
struct Signal4 : SignalEmittable4<Emitter, R0, A1, A2, A3, A4, Collector>
{
  typedef Emission4 <Emitter, R0, A1, A2, A3, A4> Emission;
  typedef Slot4<R0, A1, A2, A3, A4>               Slot;
  typedef Slot5<R0, Emitter&, A1, A2, A3, A4>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable4<Emitter, R0, A1, A2, A3, A4, Collector> SignalEmittable;
  explicit Signal4 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal4 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal4&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal4&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal4&    operator+= (R0 (*callback) (A1, A2, A3, A4))            { connect (slot (callback)); return *this; }
  Signal4&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal4);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4), Collector> : Signal4<Emitter, R0, A1, A2, A3, A4, Collector>
{
  typedef Signal4<Emitter, R0, A1, A2, A3, A4, Collector> Signal4;
  explicit Signal (Emitter &emitter) :
    Signal4 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4)) :
    Signal4 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 50000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5>
struct Emission5 : public EmissionBase {
  typedef Handler5<R0, A1, A2, A3, A4, A5>           Handler;
  typedef Handler6<R0, Emitter&, A1, A2, A3, A4, A5> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5;
  SignalBase::Link *m_last_link;
  Emission5 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5>
struct Emission5 <Emitter, void, A1, A2, A3, A4, A5> : public EmissionBase {
  typedef Handler5<void, A1, A2, A3, A4, A5>           Handler;
  typedef Handler6<void, Emitter&, A1, A2, A3, A4, A5> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5;
  Emission5 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5);
      }
  }
};

/* --- SignalEmittable5 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, class Collector>
struct SignalEmittable5 : SignalBase {
  typedef Emission5 <Emitter, R0, A1, A2, A3, A4, A5> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable5 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable5 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, class Collector>
struct SignalEmittable5 <Emitter, void, A1, A2, A3, A4, A5, Collector> : SignalBase {
  typedef Emission5 <Emitter, void, A1, A2, A3, A4, A5> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable5 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal5 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, class Collector = CollectorDefault<R0> >
struct Signal5 : SignalEmittable5<Emitter, R0, A1, A2, A3, A4, A5, Collector>
{
  typedef Emission5 <Emitter, R0, A1, A2, A3, A4, A5> Emission;
  typedef Slot5<R0, A1, A2, A3, A4, A5>               Slot;
  typedef Slot6<R0, Emitter&, A1, A2, A3, A4, A5>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable5<Emitter, R0, A1, A2, A3, A4, A5, Collector> SignalEmittable;
  explicit Signal5 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal5 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal5&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal5&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal5&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5))            { connect (slot (callback)); return *this; }
  Signal5&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal5);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5), Collector> : Signal5<Emitter, R0, A1, A2, A3, A4, A5, Collector>
{
  typedef Signal5<Emitter, R0, A1, A2, A3, A4, A5, Collector> Signal5;
  explicit Signal (Emitter &emitter) :
    Signal5 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5)) :
    Signal5 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 60000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6>
struct Emission6 : public EmissionBase {
  typedef Handler6<R0, A1, A2, A3, A4, A5, A6>           Handler;
  typedef Handler7<R0, Emitter&, A1, A2, A3, A4, A5, A6> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6;
  SignalBase::Link *m_last_link;
  Emission6 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6>
struct Emission6 <Emitter, void, A1, A2, A3, A4, A5, A6> : public EmissionBase {
  typedef Handler6<void, A1, A2, A3, A4, A5, A6>           Handler;
  typedef Handler7<void, Emitter&, A1, A2, A3, A4, A5, A6> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6;
  Emission6 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
      }
  }
};

/* --- SignalEmittable6 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, class Collector>
struct SignalEmittable6 : SignalBase {
  typedef Emission6 <Emitter, R0, A1, A2, A3, A4, A5, A6> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable6 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable6 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, class Collector>
struct SignalEmittable6 <Emitter, void, A1, A2, A3, A4, A5, A6, Collector> : SignalBase {
  typedef Emission6 <Emitter, void, A1, A2, A3, A4, A5, A6> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable6 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal6 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, class Collector = CollectorDefault<R0> >
struct Signal6 : SignalEmittable6<Emitter, R0, A1, A2, A3, A4, A5, A6, Collector>
{
  typedef Emission6 <Emitter, R0, A1, A2, A3, A4, A5, A6> Emission;
  typedef Slot6<R0, A1, A2, A3, A4, A5, A6>               Slot;
  typedef Slot7<R0, Emitter&, A1, A2, A3, A4, A5, A6>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable6<Emitter, R0, A1, A2, A3, A4, A5, A6, Collector> SignalEmittable;
  explicit Signal6 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal6 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal6&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal6&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal6&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6))            { connect (slot (callback)); return *this; }
  Signal6&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal6);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6), Collector> : Signal6<Emitter, R0, A1, A2, A3, A4, A5, A6, Collector>
{
  typedef Signal6<Emitter, R0, A1, A2, A3, A4, A5, A6, Collector> Signal6;
  explicit Signal (Emitter &emitter) :
    Signal6 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6)) :
    Signal6 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 70000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7>
struct Emission7 : public EmissionBase {
  typedef Handler7<R0, A1, A2, A3, A4, A5, A6, A7>           Handler;
  typedef Handler8<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7;
  SignalBase::Link *m_last_link;
  Emission7 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7>
struct Emission7 <Emitter, void, A1, A2, A3, A4, A5, A6, A7> : public EmissionBase {
  typedef Handler7<void, A1, A2, A3, A4, A5, A6, A7>           Handler;
  typedef Handler8<void, Emitter&, A1, A2, A3, A4, A5, A6, A7> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7;
  Emission7 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7);
      }
  }
};

/* --- SignalEmittable7 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, class Collector>
struct SignalEmittable7 : SignalBase {
  typedef Emission7 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable7 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable7 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, class Collector>
struct SignalEmittable7 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, Collector> : SignalBase {
  typedef Emission7 <Emitter, void, A1, A2, A3, A4, A5, A6, A7> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable7 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal7 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, class Collector = CollectorDefault<R0> >
struct Signal7 : SignalEmittable7<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, Collector>
{
  typedef Emission7 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7> Emission;
  typedef Slot7<R0, A1, A2, A3, A4, A5, A6, A7>               Slot;
  typedef Slot8<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable7<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, Collector> SignalEmittable;
  explicit Signal7 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal7 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal7&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal7&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal7&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7))            { connect (slot (callback)); return *this; }
  Signal7&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal7);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7), Collector> : Signal7<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, Collector>
{
  typedef Signal7<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, Collector> Signal7;
  explicit Signal (Emitter &emitter) :
    Signal7 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7)) :
    Signal7 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 80000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8>
struct Emission8 : public EmissionBase {
  typedef Handler8<R0, A1, A2, A3, A4, A5, A6, A7, A8>           Handler;
  typedef Handler9<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8;
  SignalBase::Link *m_last_link;
  Emission8 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8>
struct Emission8 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8> : public EmissionBase {
  typedef Handler8<void, A1, A2, A3, A4, A5, A6, A7, A8>           Handler;
  typedef Handler9<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8;
  Emission8 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8);
      }
  }
};

/* --- SignalEmittable8 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, class Collector>
struct SignalEmittable8 : SignalBase {
  typedef Emission8 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable8 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable8 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, class Collector>
struct SignalEmittable8 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, Collector> : SignalBase {
  typedef Emission8 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable8 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal8 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, class Collector = CollectorDefault<R0> >
struct Signal8 : SignalEmittable8<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, Collector>
{
  typedef Emission8 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8> Emission;
  typedef Slot8<R0, A1, A2, A3, A4, A5, A6, A7, A8>               Slot;
  typedef Slot9<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable8<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, Collector> SignalEmittable;
  explicit Signal8 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal8 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal8&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal8&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal8&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8))            { connect (slot (callback)); return *this; }
  Signal8&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal8);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8), Collector> : Signal8<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, Collector>
{
  typedef Signal8<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, Collector> Signal8;
  explicit Signal (Emitter &emitter) :
    Signal8 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8)) :
    Signal8 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 90000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9>
struct Emission9 : public EmissionBase {
  typedef Handler9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>           Handler;
  typedef Handler10<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9;
  SignalBase::Link *m_last_link;
  Emission9 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9>
struct Emission9 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9> : public EmissionBase {
  typedef Handler9<void, A1, A2, A3, A4, A5, A6, A7, A8, A9>           Handler;
  typedef Handler10<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9;
  Emission9 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9);
      }
  }
};

/* --- SignalEmittable9 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, class Collector>
struct SignalEmittable9 : SignalBase {
  typedef Emission9 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable9 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable9 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, class Collector>
struct SignalEmittable9 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, Collector> : SignalBase {
  typedef Emission9 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable9 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal9 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, class Collector = CollectorDefault<R0> >
struct Signal9 : SignalEmittable9<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, Collector>
{
  typedef Emission9 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9> Emission;
  typedef Slot9<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9>               Slot;
  typedef Slot10<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable9<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, Collector> SignalEmittable;
  explicit Signal9 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal9 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal9&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal9&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal9&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9))            { connect (slot (callback)); return *this; }
  Signal9&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal9);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9), Collector> : Signal9<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, Collector>
{
  typedef Signal9<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, Collector> Signal9;
  explicit Signal (Emitter &emitter) :
    Signal9 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9)) :
    Signal9 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 100000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10>
struct Emission10 : public EmissionBase {
  typedef Handler10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>           Handler;
  typedef Handler11<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10;;
  SignalBase::Link *m_last_link;
  Emission10 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10>
struct Emission10 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> : public EmissionBase {
  typedef Handler10<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>           Handler;
  typedef Handler11<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10;;
  Emission10 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10);
      }
  }
};

/* --- SignalEmittable10 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, class Collector>
struct SignalEmittable10 : SignalBase {
  typedef Emission10 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable10 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable10 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, class Collector>
struct SignalEmittable10 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Collector> : SignalBase {
  typedef Emission10 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable10 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal10 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, class Collector = CollectorDefault<R0> >
struct Signal10 : SignalEmittable10<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Collector>
{
  typedef Emission10 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10> Emission;
  typedef Slot10<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>               Slot;
  typedef Slot11<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable10<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Collector> SignalEmittable;
  explicit Signal10 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal10 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal10&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal10&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal10&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10))            { connect (slot (callback)); return *this; }
  Signal10&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal10);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10), Collector> : Signal10<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Collector>
{
  typedef Signal10<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, Collector> Signal10;
  explicit Signal (Emitter &emitter) :
    Signal10 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)) :
    Signal10 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 110000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11>
struct Emission11 : public EmissionBase {
  typedef Handler11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>           Handler;
  typedef Handler12<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11;
  SignalBase::Link *m_last_link;
  Emission11 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11>
struct Emission11 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> : public EmissionBase {
  typedef Handler11<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>           Handler;
  typedef Handler12<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11;
  Emission11 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11);
      }
  }
};

/* --- SignalEmittable11 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, class Collector>
struct SignalEmittable11 : SignalBase {
  typedef Emission11 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable11 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable11 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, class Collector>
struct SignalEmittable11 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Collector> : SignalBase {
  typedef Emission11 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable11 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal11 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, class Collector = CollectorDefault<R0> >
struct Signal11 : SignalEmittable11<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Collector>
{
  typedef Emission11 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11> Emission;
  typedef Slot11<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>               Slot;
  typedef Slot12<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable11<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Collector> SignalEmittable;
  explicit Signal11 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal11 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal11&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal11&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal11&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11))            { connect (slot (callback)); return *this; }
  Signal11&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal11);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11), Collector> : Signal11<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Collector>
{
  typedef Signal11<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, Collector> Signal11;
  explicit Signal (Emitter &emitter) :
    Signal11 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)) :
    Signal11 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 120000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12>
struct Emission12 : public EmissionBase {
  typedef Handler12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>           Handler;
  typedef Handler13<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12;
  SignalBase::Link *m_last_link;
  Emission12 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12>
struct Emission12 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> : public EmissionBase {
  typedef Handler12<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>           Handler;
  typedef Handler13<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12;
  Emission12 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12);
      }
  }
};

/* --- SignalEmittable12 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, class Collector>
struct SignalEmittable12 : SignalBase {
  typedef Emission12 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable12 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable12 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, class Collector>
struct SignalEmittable12 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Collector> : SignalBase {
  typedef Emission12 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable12 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal12 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, class Collector = CollectorDefault<R0> >
struct Signal12 : SignalEmittable12<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Collector>
{
  typedef Emission12 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12> Emission;
  typedef Slot12<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>               Slot;
  typedef Slot13<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable12<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Collector> SignalEmittable;
  explicit Signal12 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal12 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal12&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal12&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal12&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12))            { connect (slot (callback)); return *this; }
  Signal12&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal12);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12), Collector> : Signal12<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Collector>
{
  typedef Signal12<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, Collector> Signal12;
  explicit Signal (Emitter &emitter) :
    Signal12 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12)) :
    Signal12 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 130000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13>
struct Emission13 : public EmissionBase {
  typedef Handler13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>           Handler;
  typedef Handler14<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13;
  SignalBase::Link *m_last_link;
  Emission13 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13>
struct Emission13 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> : public EmissionBase {
  typedef Handler13<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>           Handler;
  typedef Handler14<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13;
  Emission13 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13);
      }
  }
};

/* --- SignalEmittable13 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, class Collector>
struct SignalEmittable13 : SignalBase {
  typedef Emission13 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable13 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable13 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, class Collector>
struct SignalEmittable13 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Collector> : SignalBase {
  typedef Emission13 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable13 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal13 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, class Collector = CollectorDefault<R0> >
struct Signal13 : SignalEmittable13<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Collector>
{
  typedef Emission13 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13> Emission;
  typedef Slot13<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>               Slot;
  typedef Slot14<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable13<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Collector> SignalEmittable;
  explicit Signal13 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal13 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal13&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal13&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal13&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13))            { connect (slot (callback)); return *this; }
  Signal13&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal13);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13), Collector> : Signal13<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Collector>
{
  typedef Signal13<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, Collector> Signal13;
  explicit Signal (Emitter &emitter) :
    Signal13 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13)) :
    Signal13 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 140000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14>
struct Emission14 : public EmissionBase {
  typedef Handler14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>           Handler;
  typedef Handler15<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13; A14 m_a14;
  SignalBase::Link *m_last_link;
  Emission14 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_a14 (a14), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14>
struct Emission14 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> : public EmissionBase {
  typedef Handler14<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>           Handler;
  typedef Handler15<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13; A14 m_a14;
  Emission14 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_a14 (a14)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14);
      }
  }
};

/* --- SignalEmittable14 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, class Collector>
struct SignalEmittable14 : SignalBase {
  typedef Emission14 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable14 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable14 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, class Collector>
struct SignalEmittable14 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Collector> : SignalBase {
  typedef Emission14 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable14 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal14 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, class Collector = CollectorDefault<R0> >
struct Signal14 : SignalEmittable14<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Collector>
{
  typedef Emission14 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14> Emission;
  typedef Slot14<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>               Slot;
  typedef Slot15<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable14<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Collector> SignalEmittable;
  explicit Signal14 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal14 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal14&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal14&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal14&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14))            { connect (slot (callback)); return *this; }
  Signal14&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal14);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14), Collector> : Signal14<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Collector>
{
  typedef Signal14<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, Collector> Signal14;
  explicit Signal (Emitter &emitter) :
    Signal14 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14)) :
    Signal14 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 150000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15>
struct Emission15 : public EmissionBase {
  typedef Handler15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>           Handler;
  typedef Handler16<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13; A14 m_a14; A15 m_a15;
  SignalBase::Link *m_last_link;
  Emission15 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_a14 (a14), m_a15 (a15), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15>
struct Emission15 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> : public EmissionBase {
  typedef Handler15<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>           Handler;
  typedef Handler16<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13; A14 m_a14; A15 m_a15;
  Emission15 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_a14 (a14), m_a15 (a15)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15);
      }
  }
};

/* --- SignalEmittable15 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, class Collector>
struct SignalEmittable15 : SignalBase {
  typedef Emission15 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable15 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable15 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, class Collector>
struct SignalEmittable15 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Collector> : SignalBase {
  typedef Emission15 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable15 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal15 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, class Collector = CollectorDefault<R0> >
struct Signal15 : SignalEmittable15<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Collector>
{
  typedef Emission15 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15> Emission;
  typedef Slot15<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>               Slot;
  typedef Slot16<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable15<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Collector> SignalEmittable;
  explicit Signal15 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal15 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal15&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal15&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal15&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15))            { connect (slot (callback)); return *this; }
  Signal15&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal15);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15), Collector> : Signal15<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Collector>
{
  typedef Signal15<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, Collector> Signal15;
  explicit Signal (Emitter &emitter) :
    Signal15 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15)) :
    Signal15 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

# 160000 "./birnetsignaltemplate.hh"

/* BirnetSignal
 * Copyright (C) 2005 Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* this file is used to generate birnetsignalvariants.hh by mksignals.sh.
 * therein, certain phrases like "typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16" are
 * rewritten into 0, 1, 2, ... 16 argument variants. so make sure all phrases
 * involving the signal argument count match those from mksignals.sh.
 */

/* --- Emission --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16>
struct Emission16 : public EmissionBase {
  typedef Handler16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>           Handler;
  typedef Handler17<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> HandlerE;
  Emitter *m_emitter;
  R0 m_result; A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13; A14 m_a14; A15 m_a15; A16 m_a16;
  SignalBase::Link *m_last_link;
  Emission16 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16) :
    m_emitter (emitter), m_result(), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_a14 (a14), m_a15 (a15), m_a16 (a16), m_last_link (NULL)
  {}
  /* call Handler and store result, so handler templates need no <void> specialization */
  R0 call (SignalBase::Link *link)
  {
    if (m_last_link != link)
      {
        if (link->with_emitter)
          {
            HandlerE *handler = handler_cast<HandlerE*> (link);
            if (handler->callable)
              m_result = (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15, m_a16);
          }
        else
          {
            Handler *handler = handler_cast<Handler*> (link);
            if (handler->callable)
              m_result = (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15, m_a16);
          }
        m_last_link = link;
      }
    return m_result;
  }
};
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16>
struct Emission16 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> : public EmissionBase {
  typedef Handler16<void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>           Handler;
  typedef Handler17<void, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> HandlerE;
  Emitter *m_emitter;
  A1 m_a1; A2 m_a2; A3 m_a3; A4 m_a4; A5 m_a5; A6 m_a6; A7 m_a7; A8 m_a8; A9 m_a9; A10 m_a10; A11 m_a11; A12 m_a12; A13 m_a13; A14 m_a14; A15 m_a15; A16 m_a16;
  Emission16 (Emitter *emitter, A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16) :
    m_emitter (emitter), m_a1 (a1), m_a2 (a2), m_a3 (a3), m_a4 (a4), m_a5 (a5), m_a6 (a6), m_a7 (a7), m_a8 (a8), m_a9 (a9), m_a10 (a10), m_a11 (a11), m_a12 (a12), m_a13 (a13), m_a14 (a14), m_a15 (a15), m_a16 (a16)
  {}
  /* call the handler and ignore result, so handler templates need no <void> specialization */
  void call (SignalBase::Link *link)
  {
    if (link->with_emitter)
      {
        HandlerE *handler = handler_cast<HandlerE*> (link);
        if (handler->callable)
          (*handler) (*m_emitter, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15, m_a16);
      }
    else
      {
        Handler *handler = handler_cast<Handler*> (link);
        if (handler->callable)
          (*handler) (m_a1, m_a2, m_a3, m_a4, m_a5, m_a6, m_a7, m_a8, m_a9, m_a10, m_a11, m_a12, m_a13, m_a14, m_a15, m_a16);
      }
  }
};

/* --- SignalEmittable16 --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, class Collector>
struct SignalEmittable16 : SignalBase {
  typedef Emission16 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> Emission;
  typedef typename Collector::result_type     Result;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    R0 operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable16 (Emitter *emitter) : m_emitter (emitter) {}
  inline Result emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    Result result = collector (it, last);
    return result;
  }
private:
  Emitter *m_emitter;
};
/* SignalEmittable16 for void returns */
template<class Emitter, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, class Collector>
struct SignalEmittable16 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Collector> : SignalBase {
  typedef Emission16 <Emitter, void, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> Emission;
  struct Iterator : public SignalBase::Iterator<Emission> {
    Iterator (Emission &emission, Link *link) : SignalBase::Iterator<Emission> (emission, link) {}
    void operator* () { return this->emission.call (this->current); }
  };
  explicit SignalEmittable16 (Emitter *emitter) : m_emitter (emitter) {}
  inline void emit (A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11, A12 a12, A13 a13, A14 a14, A15 a15, A16 a16)
  {
    ScopeReference<Emitter, Collector> lref (*m_emitter);
    Emission emission (m_emitter, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16);
    Iterator it (emission, &start), last (emission, &start);
    ++it; /* walk from start to first */
    Collector collector;
    collector (it, last);
  }
private:
  Emitter *m_emitter;
};

/* --- Signal16 --- */
/* Signal* */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, class Collector = CollectorDefault<R0> >
struct Signal16 : SignalEmittable16<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Collector>
{
  typedef Emission16 <Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16> Emission;
  typedef Slot16<R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>               Slot;
  typedef Slot17<R0, Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16>     SlotE;
  typedef typename SignalBase::Link           Link;
  typedef SignalEmittable16<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Collector> SignalEmittable;
  explicit Signal16 (Emitter &emitter) :
    SignalEmittable (&emitter)
  { assert (&emitter != NULL); }
  explicit Signal16 (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16)) :
    SignalEmittable (&emitter)
  {
    assert (&emitter != NULL);
    connect (slot (emitter, method));
  }
  inline void connect    (const Slot  &s) { connect_link (s.get_handler()); }
  inline void connect    (const SlotE &s) { connect_link (s.get_handler(), true); }
  Signal16&    operator+= (const Slot  &s) { connect (s); return *this; }
  Signal16&    operator+= (const SlotE &s) { connect (s); return *this; }
  Signal16&    operator+= (R0 (*callback) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16))            { connect (slot (callback)); return *this; }
  Signal16&    operator+= (R0 (*callback) (Emitter&, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16))  { connect (slot (callback)); return *this; }
  BIRNET_PRIVATE_CLASS_COPY (Signal16);
};

/* --- Signal<> --- */
template<class Emitter, typename R0, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename A8, typename A9, typename A10, typename A11, typename A12, typename A13, typename A14, typename A15, typename A16, class Collector>
struct Signal<Emitter, R0 (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16), Collector> : Signal16<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Collector>
{
  typedef Signal16<Emitter, R0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, Collector> Signal16;
  explicit Signal (Emitter &emitter) :
    Signal16 (emitter)
    {}
  explicit Signal (Emitter &emitter, R0 (Emitter::*method) (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16)) :
    Signal16 (emitter, method)
    {}
  BIRNET_PRIVATE_CLASS_COPY (Signal);
};

